#include "Infomap.h"

typedef infomap::InfomapWrapper IW;

extern "C" {
  struct network;

  struct cluster_node {
    unsigned int node, cluster_id;
  };

  network* network_create(const char* cfgstr) {
    IW* iw = new infomap::InfomapWrapper(cfgstr);
    return reinterpret_cast<network*>(iw);
  }
  void network_destroy(network* n) {
    delete reinterpret_cast<IW*>(n);
  }

  void add_link(network* n, unsigned int i, unsigned int j, double w) {
    reinterpret_cast<IW*>(n)->addLink(i, j, w);
  }

  void run(network* n) {
    reinterpret_cast<IW*>(n)->run();
  }

  double get_codelength(network* n) {
    return reinterpret_cast<IW*>(n)->codelength();
  }

  unsigned int get_num_nodes(network* n) {
    return reinterpret_cast<IW*>(n)->network().numNodes();
  }

  void write_modules(network* n, cluster_node* nodes) {
    auto modules = reinterpret_cast<IW*>(n)->getModules();
    int i = 0;
    for(auto node : modules) {
      nodes[i] = {node.first, node.second};
      i++;
    }
  }
};
