module Data.Graph.Infomap where

import Data.Graph.Infomap.Internal
import Data.Map
import Foreign.C.Types

import qualified Data.Map as Map

infomap :: NetworkCfg -> Map (Int, Int) Double -> IO [CNode]
infomap cfg edges = withNetwork cfg $ \n -> do
  addLinks n edges
  run n
  getModules n

  where addLinks n = Map.foldrWithKey (go n) (return ())
        go n (i, j) w act = addLink n (fromIntegral i)
                                      (fromIntegral j)
                                      (CDouble w)
                         >> act

testHigh = infomap "--silent --two-level -N2" testmap
  where testmap = Map.fromList
          [ ((0, 1), 1.0)
          , ((0, 2), 1.0)
          , ((0, 3), 1.0)
          , ((1, 0), 1.0)
          , ((1, 2), 1.0)
          , ((2, 1), 1.0)
          , ((2, 0), 1.0)
          , ((3, 0), 1.0)
          , ((3, 4), 1.0)
          , ((3, 5), 1.0)
          , ((4, 3), 1.0)
          , ((4, 5), 1.0)
          , ((5, 4), 1.0)
          , ((5, 3), 1.0)
          ]
